<?php

  class mw_sgbd
  {
    protected $sgbd_impl;
    protected $env;

    function __construct($sgbd_impl, $env)
    { $this->sgbd_impl = $sgbd_impl;
      $this->env = $env;
    }

    function connect($host, $base, $user, $password)
    { $this->sgbd_impl->connect($host, $base, $user, $password);
    }

    function select_db($db_name)
    { $this->sgbd_impl->select_db($db_name);
    }

    function query($sql)
    { $rst = $this->sgbd_impl->query
      ( ($prefix_codes = array_keys($this->env->bdd("table_prefix"))) ?
          str_replace($prefix_codes, array_values($this->env->bdd("table_prefix")), $sql)
        : $sql
      );
      if($rst) return $rst;
      throw new Exception("  [erreur] sql : erreur dans une requete");
    }

    function insert_id()
    { return $this->sgbd_impl->insert_id();
    }

    function fetch_assoc($rst)
    { return $this->sgbd_impl->fetch_assoc($rst);
    }

    function free_result($rst)
    { return $this->sgbd_impl->free_result($rst);
    }

    function close()
    { return $this->sgbd_impl->close();
    }

  }

?>