<?php

  class mw_env_run extends mw_env
  {

    function set_etat($etat)
    { $this->env->etat = array();
      $this->env->etat["mod"] = "";
      $this->env->etat["controller"] = "";
      $this->env->etat["action"] = "";
      if(is_array($etat))
      { $this->env->etat["mod"] = isset($etat["mod"]) ? $etat["mod"] : "";
        $this->env->etat["controller"] = isset($etat["controller"]) ? $etat["controller"] : "";
        $this->env->etat["action"] = isset($etat["action"]) ? $etat["action"] : "";
      }
      else
      { $etat = explode("/", $etat);
        foreach($etat as $etat_item)
        { if($etat_item)
          { if(!$this->env->etat["mod"]) $this->env->etat["mod"] = $etat_item;
            else
            { if(!$this->env->etat["controller"]) $this->env->etat["controller"] = $etat_item;
              else
              { if(!$this->env->etat["action"]) $this->env->etat["action"] = $etat_item;
                break;
              }
            }
          }
        }
      }
      if(!$this->env->etat["mod"])
      { $this->env->etat["mod"] = "index";
        $this->env->etat["controller"] = "index";
        $this->env->etat["action"] = "index";
      }
      else
      { if(!$this->env->etat["controller"])
        { $this->env->etat["controller"] = "index";
          $this->env->etat["action"] = "index";
        }
        else
        { if(!$this->env->etat["action"]) $this->env->etat["action"] = "index";
        }
      }
      if(!$this->etat_is_valid())
      { $this->erreur("etat invalide");
        return false;
      }
      return true;
    }

    function etat_is_valid()
    { return
         is_array($this->env->etat)
      && count($this->env->etat) == 3
      && isset($this->env->etat["mod"]) && preg_match("/^[a-zA-Z0-9_]+$/", $this->env->etat["mod"])
      && isset($this->env->etat["controller"]) && preg_match("/^[a-zA-Z0-9_]+$/", $this->env->etat["controller"])
      && isset($this->env->etat["action"]) && preg_match("/^[a-zA-Z0-9_]+$/", $this->env->etat["action"]);
    }

    function run($etat)
    { if($this->set_etat($etat))
      { if($this->app_file_exists($controller_file = "mods/".$this->etat("mod")."/".$this->etat("controller").".php"))
        { if(!class_exists("mw_mod")) require $this->app_file("mods/mw_mod.php");
          if(!class_exists($controller_class = "mw_".$this->etat("mod")."_".$this->etat("controller")))
          { require $this->app_file($controller_file);
          }
          if(class_exists($controller_class))
          { if(method_exists($controller_class, $action_method = $this->etat("action")))
            { $controller = new $controller_class($this->env);
              $controller->$action_method();
            }
            else $this->erreur("Impossible de trouver l'action ".$this->etat("action"));
          }
          else $this->erreur("Impossible d'instancier le controleur ".$this->etat("controller"));
        }
        else $this->erreur("Impossible de trouver le controleur ".$this->etat("controller")." pour le module ".$this->etat("mod"));
      }
    }

    function etat($name) { return $this->env->etat[$name]; }

    function check_stop()
    { return $this->etat("mod") == "reponses";
    }

  }

?>