<?php

  class mw_data_users extends mw_data
  {

    # ----------------------------------------------------------------------------------------
    #                                                                                    users
    #

    function users($start = 0, $alpha = null)
    { $users = array("list" => array(), "total" => 0);
      try
      { $SELECT = "SELECT #--users.login";
        $FROM = " FROM #--users";
        $WHERE = "";
        $WHERE .= (isset($alpha) ? ($WHERE ? " AND" : " WHERE")." LEFT(login, 1)=".$this->eq($alpha) : "");
        $LIMIT = ($this->env->config("max_list") ? " LIMIT ".$this->env->config("max_list")." OFFSET ".$start : "");
        $sql = "SELECT count(*) as n FROM(".$SELECT.$FROM.$WHERE.") res";
        $rst = $this->sgbd->query($sql);
        if($v_rst = $this->sgbd->fetch_assoc($rst)) $users["total"] = $v_rst["n"];
        $this->sgbd->free_result($rst);
        if($users["total"] > 0)
        { $sql = "SELECT * FROM(".$SELECT.$FROM.$WHERE.$LIMIT.") res";
          $rst = $this->sgbd->query($sql);
          while($v_rst = $this->sgbd->fetch_assoc($rst)) $users["list"][$v_rst["id"]] = $v_rst;
          $this->sgbd->free_result($rst);
        }
      }
      catch(Exception $_e) { $users = false; }
      return $users;
    }

    function user($login)
    { $user = array();
      try
      { $sql = "SELECT * from #--users WHERE login=".$this->eq($login);
        $rst = $this->sgbd->query($sql);
        if($v_rst = $this->sgbd->fetch_assoc($rst)) $user = $v_rst;
        $this->sgbd->free_result($rst);
      }
      catch(Exception $_e) { $user = false; }
      return $user;
    }

    function add_user($login, $password, $email, $admin)
    { try
      { $sql =
         "INSERT INTO #--users(login, password, email, admin) VALUES"
        ."( ".$this->eq($login)
        .", ".$this->eq($password)
        .", ".$this->eq($email)
        .", ".$admin
        .")";
        $this->sql->query($sql);
      }
      catch(Exception $_e) { return false; }
      return true;
    }

    function set_user($login, $password, $email, $admin)
    { try
      { $sql =
         "UPDATE #--users SET"
        .", login=".$this->eq($login)
        .", password=".$this->eq($password)
        .", email=".$this->eq($email)
        .", admin=".$admin
        ." WHERE id=".$id;
        $this->sql->query($sql);
      }
      catch(Exception $_e) { return false; }
      return true;
    }

    function del_user($login)
    { try
      { $sql = "DELETE FROM #--users WHERE login=".$login;
        $this->sql->query($sql);
      }
      catch(Exception $_e) { return false; }
      return true;
    }

    # ----------------------------------------------------------------------------------------
    #                                                                                    admin
    #

    function is_admin($login)
    { $IS_ADMIN = 0;
      try
      { $sql = "SELECT admin FROM #--users WHERE login=".$this->eq($login);
        $rst = $this->sgbd->query($sql);
        if($v_rst = $this->sgbd->fetch_assoc($rst)) $IS_ADMIN = $v_rst["admin"];
        $this->sgbd->free_result($rst);
      }
      catch(Exception $_e) { $IS_ADMIN = false; }
      return $IS_ADMIN;
    }

    # ----------------------------------------------------------------------------------------
    #                                                                             log in / out
    #

    function login($login, $password)
    { if(($user = $this->user($login)) !== false)
      { if($this->password_ok($user, $password))
        { if(!$this->set_session($user)) $user = false;
        }
        else
        { $this->clear_session();
          $user = array();
        }
      }
      return $user;
    }

    function logout()
    { return $this->clear_session();
    }

    function user_ok($user)
    { return
      strcmp(md5($user["password"].$_SESSION["id"]), $_SESSION["pass"]) == 0
      && $_SESSION["ip"] == $_SERVER["REMOTE_ADDR"];
    }

    function password_ok($user, $password)
    { return
      strcmp(md5($user["password"].$_SESSION["id"]), $password) == 0
      && $_SESSION["ip"] == $_SERVER["REMOTE_ADDR"];
    }

    # ----------------------------------------------------------------------------------------
    #                                                                                  session
    #

    function load_session()
    { session_start();
      if(!isset($_SESSION["id"])) $this->clear_session();
      if
      ( $user =
        ( $_COOKIE["user"] || $_SESSION["user"] ?
            $this->user($_COOKIE["user"] ? $_COOKIE["user"] : $_SESSION["user"])
          : array()
        )
      )
      { if(!$this->user_ok($user))
        { $this->clear_session();
          $user = array();
        }
      }
      return $user;
    }

    function set_session($user)
    { $_SESSION["user"] = $user["login"];
      $_SESSION["pass"] = md5($user["password"].$_SESSION["id"]);
      setcookie("user", $user["login"], time() + (60 * 60 * 24 * 7));
      return true;
    }

    function clear_session()
    { unset($_SESSION["user"]);
      unset($_SESSION["pass"]);
      $_SESSION["ip"] = $_SERVER["REMOTE_ADDR"];
      $_SESSION["id"] = md5(rand());
      setcookie("user", "", time() + (60 * 60 * 24 * 7));
      return true;
    }

  }

?>