<?php

  # --------------------------------------------------------------
  #                                                          infos
  #

  # modifier ce fichier en fonction de l'organisation des dossier
  # et des parametres de connection au sgbd

  # les valeurs indiquees ci-dessous correspondent a la configuration
  # suivante :
  #
  # - le fichier "index.php" du site
  #   (celui appele par les internautes)
  #   est accessible via l'url :
  #   http://un.domaine.ltd/mountweb/web/index.php
  #
  # - sur le serveur, le dossier "/mountweb/web/" contient lui-meme
  #   un dossier "mountweb" (celui extrait de l'archive)
  #
  # - le dossier mountweb de l'archive contient (entre autres) les dossiers :
  #
  #    - app/core
  #    - app/local
  #    - out/dist
  #    - out/local
  #    - content
  # 

  # --------------------------------------------------------------
  #                                                        chemins
  #

  # chemin web du site (dossier d'execution du script d'appel)
  # absolu a partir du "document root"
  $PATHES["web"] = "/mtweb/web";

  # chemin de l'application
  # relatif au dossier d'execution du script
  $PATHES["app"] = "mtweb/app";

  # nom du dossier (sans chemin) de l'application courante
  $PATHES["current_app"] = "local";

  # nom du dossier (sans chemin) de l'application par defaut
  $PATHES["core_app"] = "core";

  # dossier des uploads
  # relatif au dossier d'execution du script
  $PATHES["content"] = "mtweb/content";

  # dossier des templates
  # relatif au dossier d'execution du script
  $PATHES["out"] = "mtweb/out";

  # nom du dossier (sans chemin) du template courant
  $PATHES["current_out"] = "local";

  # nom du dossier (sans chemin) du template par defaut
  $PATHES["dist_out"] = "dist";

  # --------------------------------------------------------------
  #                                                base de donnees
  #

  # --------------------------- MYSQL

  # sgbd : "mysql" ou "sqlite"
  $bdd["sgbd"] = "mysql";

  # parametres de connection
  $bdd["host"] = "localhost";
  $bdd["base"] = "mtweb_mysql_base";
  $bdd["table_prefix"] = "mw_";
  $bdd["user"] = "mtweb_mysql_user";
  $bdd["password"] = "mtweb_mysql_pass";

  # --------------------------- SQLITE

  # sgbd : "mysql" ou "sqlite"
  //$bdd["sgbd"] = "sqlite";

  # parametres de connection
  //$bdd["host"] = "mtweb/content/data/sqlite";
  //$bdd["base"] = "mw";
  //$bdd["table_prefix"] = "mw_";


?>